//Definir variables
const int p1 = A0;
const int p2 = A1;
const int p3 = A2;
int boton = 5;
int contador = 1;


//Incluir la librería para controlar los neopixeles
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
 #include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

//Definir pin de conexión de los neopixeles y número de neopixeles
#define PIN        6 
#define NUMPIXELS 16 
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);


//Incluir la librería y definir pin de conexion para controlar 
//el sensor dht11 de temperatura y humedad
#include "DHT.h"
#define DHTPIN 2     
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);


void setup() {
  dht.begin();                       //inicializamos el sensor dht11
  pixels.begin();                    //inicializamos los neopixeles
}


//Programa que se ejecuta infinitamente
void loop() {
 
  int estado = digitalRead(boton);  //lee el estado del botón (normalmente bajo)
  if (estado == HIGH){              //Si el estado es alto suma 1 al contador
    contador ++;
    }

  //Utiliza la funcion par para revisar si el contador esta en un número par o impar
  if (par(contador) == "Impar"){   
  manual();                         //Si el contador es impar ejecuta la funcion manual
  }
  
  else {
    automatico();                //Si el contador es par ejecuta la funcion automatico
  }
 pixels.show(); //Enciende los neopixeles
}


//funcion manual
void manual(){
  
  pixels.clear();             //limpia los neopixeles
  int a0 = analogRead(p1);    //Lee el valor analógico del primer potenciometro
  int a1 = analogRead(p2);    //Lee el valor analógico del segundo potenciometro
  int a2 = analogRead(p3);    //Lee el valor analógico del tercer potenciometro

  //divide los valores analógicos entre 4 para tener valores entre 0 y 255
  int val1 = a0/4;
  int val2 = a1/4;
  int val3 = a2/4;

  //Programa los neopixeles con el valor de un potenciometro por cada color
  for(int i=0; i<NUMPIXELS; i++) { 
    pixels.setPixelColor(i, pixels.Color(val1, val2, val3));
  }
  
}


//Función automatico
void automatico(){     //Indicamos los parametros que recibira (temperatura y humedad)
  pixels.clear();

  delay(500); //pausa de medio segundo entre mediciones
  float h = dht.readHumidity();     //lee la humedad y la guarda en la variable h
  float t = dht.readTemperature();  //lee la humedad y la guarda en la variable t
  
  //Si la temperatura es menor  25°C
  if (t<25){
    if (h<40){                   //Si la humedad es menor a 40%
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(160,160,160));   //Programa color gris
        }
      }
    if (h>=40 && h<=70){         //Si la humedad está entre 40 y 70 %
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(255, 102, 178)); //Programa color fusia
        }
      }
    if (h>70){                  //Si la humedad es mayor a 70%
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(0, 0, 200 ));    //Programa color azul
        }
      }
    }

  //Si la temperatura es mayor a 25°C y menor a 32°C
  if (t>=25 && t<=32){
    
    if (h<40){                 //Si la humedad es menor a 40%
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(0,255, 255));    //Programa color rosa
        }
      }
    if (h>=40 && h<=70){       //Si la humedad está entre 40 y 70 %
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(0, 200, 0));    //Programa color verde
        }
      }
    if (h>70){                //Si la humedad es mayor a 70%
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(75, 0, 150));   //Programa color morado
        }
      }
    }

  //Si la temperatura es mayor a 32°C
  if (t>32){ 
    if (h<40){               //Si la humedad es menor a 40%
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(200, 0, 0));    //Programa color rojo
        }
      }
    if (h>=40 && h<=70){     //Si la humedad está entre 40 y 70 %
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(204, 102, 0));  //Programa color naranja
        }
      }
    if (h>70){               //Si la humedad es mayor a 70%
      for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(255, 255, 0 )); //Programa color amarillo
        }
      }
    }

}

//Funcion par
String par(int cont){
  if(cont & 0x01)           //Revisa si es impar
    return "Impar";         //Si es impar retorna "impar"
  else
    return "Par";           //Si no es impar retorna "par"
  }
